//MAT259 2D Spatial Mapping. LiZheng. 02/05/2014
import de.bezier.data.sql.*;
import de.bezier.data.sql.mapper.*;

MySQL msql;
String[] text = new String[1];
String DL = ",";
int w = 960;
int h = 800;
int legendSpace = w/8;
int titleSpace = h/25;
int brOff = w/10;
int hH = h - titleSpace - brOff;
int wH = w - legendSpace - brOff;


int [][] basketball;
int [][] baseball;
int [][] football;
int [][] hockey;
color [] colors = {color(0,0,255),color(0,255,0),color(255,0,0),color(255,255,0),color(255,255,0),color(0,255,255),color(125,125,255),color(125,255,125),color(255,125,125),color(125,125,125)};
String [] year = {"2006", "2007", "2008", "2009", "2010", "2011", "2012", "2013"};
int [] month = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12};
String [] sports = {"basketball", "baseball", "football", "hockey"};
String [] number = {"0", "600", "1200", "1800", "2400", "3000", "3600", "4200", "4800"};
void setup (){
  /*msql = new MySQL (this, "tango.mat.ucsb.edu", "spl2", "mat259", "V1sual1zat1on");
  if (msql.connect())
  {
    String Query = "select month(cout) as 'Month', year(cout) as 'Year', \n
    sum(case when(`subject`.`subject` like '%basketball%') then 1 else 0 end) as 'Basketball', \n
    sum(case when(`subject`.`subject` like '%baseball%') then 1 else 0 end) as 'Baseball', \n
    sum(case when(`subject`.`subject` like '%football%') then 1 else 0 end) as 'Football', \n
    sum(case when(`subject`.`subject` like '%hockey%') then 1 else 0 end) as 'Ice Hockey' \n
    from inraw, `subject` where inraw.`bibNumber`=`subject`.`bib` and year(cout) >= 2006 group by year(cout), month(cout)order by year(cout), month(cout) asc";
    msql.query (Query);
    text[0] = Query;
    while (msql.next())
    {
      text = append (text, msql.getString(1) + DL + msql.getString(2) + DL + msql.getString(3) + DL + msql.getString(4) + DL + msql.getString(5) + DL + msql.getString(6));
    }
  }
  else
  {
    println ("connection failed!");
  }
  saveStrings ("saveData.txt", text);*/
  basketball = new int[8][13];
  baseball = new int[8][13];
  football = new int[8][13];
  hockey = new int[8][13];
  String file = "saveData.txt";
  String [] textData = loadStrings (file);
  for (int i = 1; i < textData.length; i++)
  {
    String textSplitted[] = split (textData[i], ",");
    int m = (int)Integer.parseInt(textSplitted[0]);
    int y = (int)Integer.parseInt(textSplitted[1]);
    int basket = (int)Integer.parseInt(textSplitted[2]);
    int base = (int)Integer.parseInt(textSplitted[3]);
    int foot = (int)Integer.parseInt(textSplitted[4]);
    int hkey = (int)Integer.parseInt(textSplitted[5]);
    println (m + "," + y + "," + basket + "," + base + "," + foot + "," + hkey);
    basketball[y-2006][m] = basket;
    baseball[y-2006][m] = base;
    football[y-2006][m] = foot;
    hockey[y-2006][m] = hkey;
  }
  size (w, h);
}

void draw ()
{
  background (100);
  for (int i = 0; i < 4; i++)
  {
    fill (colors[i]);
    ellipse (w-legendSpace*0.3, h/8+3*h/4/10*i, 15, 15);
    fill(255);
    textSize(15);
    text(sports[i], w-legendSpace*0.4-40, h/8+3*h/4/10*i);
  }
  textSize (15);
  stroke(0);
  fill(0);
  for (int i = 0; i < 8; i++)
  {
    textAlign (CENTER);
    fill(255);
    text (year[i], 1.2*brOff+wH/8*i, h-0.5*brOff);
  }
  for (int i = 0; i < 9; i++)
  {
    text(number[i], 0.5*brOff, h-brOff-h/10*i);
  }
  float sx = 1.2*brOff, ex = 1.2*brOff+wH;
  float sy = h-brOff, ey = h-brOff-h/10*8;
  float cx, cy, r;
  int val, zoom;
  float total;
  zoom = 10;
  total = 4800;
  for (int i = 0; i < 8; i++)
  {
    for (int j = 1; j <= 12; j++)
    {
      val = basketball[i][j];
      fill(colors[0]);
      cx = sx + (i*12+j)/96.0*(ex-sx) - 40;
      cy = sy + (val/total)*(ey-sy);
      r = (val/total)*zoom;
      ellipse(cx, cy, 2*r, 2*r);
      
      val = baseball[i][j];
      fill(colors[1]);
      cx = sx + (i*12+j)/96.0*(ex-sx) - 40;
      cy = sy + (val/total)*(ey-sy);
      r = (val/total)*zoom;
      ellipse(cx, cy, 2*r, 2*r);
      
      val = football[i][j];
      fill(colors[2]);
      cx = sx + (i*12+j)/96.0*(ex-sx) - 40;
      cy = sy + (val/total)*(ey-sy);
      r = (val/total)*zoom;
      ellipse(cx, cy, 2*r, 2*r);
      
      val = hockey[i][j];
      fill(colors[3]);
      cx = sx + (i*12+j)/96.0*(ex-sx) - 40;
      cy = sy + (val/total)*(ey-sy);
      r = (val/total)*zoom*3;
      ellipse(cx, cy, 2*r, 2*r);
    }
  }
  fill(255);
  textSize(20);
  text("Trend of Most Popular Sports Books", w/2, titleSpace);
  textSize(15);
  textAlign(CENTER);
  text("Year", w/2,h-brOff*0.2);
  textAlign(CENTER, CENTER);
  rotate(-HALF_PI);
  text("Books checked out", -400, 10);
}

